# Retrieve transfer options

Generate available payment method options for one or multiple transfer participants depending on the accountID or paymentMethodID you supply in the request body.

The accountID in the route should be the partner's accountID.

Read our [transfers overview guide](https://docs.moov.io/guides/money-movement/overview/) to learn more.

To access this endpoint using an [access token](https://docs.moov.io/api/authentication/access-tokens/) you'll need to specify the "/accounts/{accountID}/transfers.write" scope.

### POST

`/accounts/{accountID}/transfer-options`

### Ask

```shell
curl -X POST "https://api.moov.io/accounts/{accountID}/transfer-options" \
  -H "Authorization: Bearer {token}" \
  -H "X-Moov-Version: v2026.07.00" \
  -d '{
  "source": {},
  "destination": {},
  "amount": {
    "currency": "USD",
    "value": 1204
  }
}'
```

### Ask

```go
mc, _ := moov.NewClient()

// your partner accountID
var accountID string

mc.TransferOptions(ctx, accountID, moov.CreateTransferOptions{
  Source: moov.CreateTransferOptionsTarget{
    AccountID: "string",
  },
  Destination: moov.CreateTransferOptionsTarget{
    AccountID: "string",
  },
  Amount: moov.Amount{
    Currency: "USD",
    Value:    1,
  },
})
```

### Ask

```typescript
import { Moov } from "@moovio/sdk";

const moov = new Moov({
  security: {
    username: "",
    password: "",
  },
});

async function run() {
  const result = await moov.transfers.generateOptions({
    accountID: "deafe3cf-31d4-4dcc-8176-3d6bf8bb4f04",
    createTransferOptions: {
      source: {},
      destination: {},
      amount: {
        currency: "USD",
        value: 1204,
      },
    },
  });

console.log(result);
}

run();
```

### Ask

```php
declare(strict_types=1);

require 'vendor/autoload.php';

use Moov\MoovPhp;
use Moov\MoovPhp\Models\Components;

$sdk = MoovPhp\Moov::builder()
    ->setSecurity(
        new Components\Security(
            username: '',
            password: '',
        )
    )
    ->build();

$createTransferOptions = new Components\CreateTransferOptions(
    source: new Components\SourceDestinationOptions(),
    destination: new Components\SourceDestinationOptions(),
    amount: new Components\Amount(
        currency: 'USD',
        value: 1204,
    ),
);

$response = $sdk->transfers->generateOptions(
    accountID: 'deafe3cf-31d4-4dcc-8176-3d6bf8bb4f04',
    createTransferOptions: $createTransferOptions
);

if ($response->transferOptions !== null) {
    // handle response
}
```

### Ask

```java
package hello.world;

import io.moov.sdk.Moov;
import io.moov.sdk.models.components.*;
import io.moov.sdk.models.errors.GenericError;
import io.moov.sdk.models.errors.TransferOptionsValidationError;
import io.moov.sdk.models.operations.CreateTransferOptionsResponse;
import java.lang.Exception;

public class Application {

public static void main(String[] args) throws GenericError, TransferOptionsValidationError, Exception {

Moov sdk = Moov.builder()
                .security(Security.builder()
                    .username("")
                    .password("")
                    .build())
            .build();

CreateTransferOptionsResponse res = sdk.transfers().generateOptions()
                .accountID("deafe3cf-31d4-4dcc-8176-3d6bf8bb4f04")
                .createTransferOptions(CreateTransferOptions.builder()
                    .source(SourceDestinationOptions.builder()
                        .build())
                    .destination(SourceDestinationOptions.builder()
                        .build())
                    .amount(Amount.builder()
                        .currency("USD")
                        .value(1204L)
                        .build())
                    .build())
                .call();

if (res.transferOptions().isPresent()) {
            System.out.println(res.transferOptions().get());
        }
    }
}
```

### Ask

```python
from moovio_sdk import Moov
from moovio_sdk.models import components

with Moov(
    security=components.Security(
        username="",
        password="",
    ),
) as moov:

res = moov.transfers.generate_options(account_id="deafe3cf-31d4-4dcc-8176-3d6bf8bb4f04", source={}, destination={}, amount={
        "currency": "USD",
        "value": 1204,
    })

# Handle response
    print(res)
```

### Ask

```ruby
require 'moov_ruby'

Models = ::Moov::Models
s = ::Moov::Client.new(
  security: Models::Components::Security.new(
    username: '',
    password: ''
  )
)
res = s.transfers.generate_options(account_id: 'deafe3cf-31d4-4dcc-8176-3d6bf8bb4f04', create_transfer_options: Models::Components::CreateTransferOptions.new(
  source: Models::Components::SourceDestinationOptions.new,
  destination: Models::Components::SourceDestinationOptions.new,
  amount: Models::Components::Amount.new(
    currency: 'USD',
    value: 1204
  )
))

unless res.transfer_options.nil?
  # handle response
end
```

### Ask

```csharp
using Moov.Sdk;
using Moov.Sdk.Models.Components;

var sdk = new MoovClient(security: new Security() {
    Username = "",
    Password = "",
});

var res = await sdk.Transfers.GenerateOptionsAsync(
    accountID: "deafe3cf-31d4-4dcc-8176-3d6bf8bb4f04",
    body: new CreateTransferOptions() {
        Source = new SourceDestinationOptions() {},
        Destination = new SourceDestinationOptions() {},
        Amount = new Amount() {
            Currency = "USD",
            Value = 1204,
        },
    }
);

// handle response
```

### Example Response

```json
{
  "sourceOptions": [
    {
      "paymentMethodID": "b7a60692-ab86-4eb0-b961-3bb4a714aa42",
      "paymentMethodType": "moov-wallet",
      "wallet": {
        "walletID": "string",
        "partnerAccountID": "c197cd40-7745-4413-8f3b-ec962d1b5225",
        "walletType": "default"
      }
    }
  ],
  "destinationOptions": [
    {
      "paymentMethodID": "b7a60692-ab86-4eb0-b961-3bb4a714aa42",
      "paymentMethodType": "moov-wallet",
      "wallet": {
        "walletID": "string",
        "partnerAccountID": "c197cd40-7745-4413-8f3b-ec962d1b5225",
        "walletType": "default"
      }
    }
  ]
}
```
